#
# spec file for package qemu
#
# Copyright (c) 2013 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%ifarch %ix86 x86_64
# choice of building all from source or using provided binary x86 blobs
%define build_x86_fw_from_source 1
%else
%define build_x86_fw_from_source 0
%endif

Name:           qemu
Url:            http://www.qemu.org/
Summary:        Universal CPU emulator
License:        BSD-3-Clause and GPL-2.0 and GPL-2.0+ and LGPL-2.1+ and MIT
Group:          System/Emulators/PC
Version:        1.6.0
Release:        0
Source:         %name-1.6.0.tar.bz2
# This patch queue is auto-generated from https://github.com/openSUSE/qemu
Patch0001:      0001-XXX-dont-dump-core-on-sigabort.patc.patch
Patch0002:      0002-XXX-work-around-SA_RESTART-race-wit.patch
Patch0003:      0003-qemu-0.9.0.cvs-binfmt.patch.patch
Patch0004:      0004-qemu-cvs-alsa_bitfield.patch.patch
Patch0005:      0005-qemu-cvs-alsa_ioctl.patch.patch
Patch0006:      0006-qemu-cvs-alsa_mmap.patch.patch
Patch0007:      0007-qemu-cvs-gettimeofday.patch.patch
Patch0008:      0008-qemu-cvs-ioctl_debug.patch.patch
Patch0009:      0009-qemu-cvs-ioctl_nodirection.patch.patch
Patch0010:      0010-block-vmdk-Support-creation-of-SCSI.patch
Patch0011:      0011-linux-user-add-binfmt-wrapper-for-a.patch
Patch0012:      0012-linux-user-Ignore-timer_create-sysc.patch
Patch0013:      0013-linux-user-be-silent-about-capget-f.patch
Patch0014:      0014-PPC-KVM-Disable-mmu-notifier-check..patch
Patch0015:      0015-linux-user-fix-segfault-deadlock.pa.patch
Patch0016:      0016-linux-user-binfmt-support-host-bina.patch
Patch0017:      0017-linux-user-arm-no-tb_flush-on-reset.patch
Patch0018:      0018-linux-user-Ignore-broken-loop-ioctl.patch
Patch0019:      0019-linux-user-lock-tcg.patch.patch
Patch0020:      0020-linux-user-Run-multi-threaded-code-.patch
Patch0021:      0021-linux-user-lock-tb-flushing-too.pat.patch
Patch0022:      0022-linux-user-Fake-proc-cpuinfo.patch.patch
Patch0023:      0023-linux-user-implement-FS_IOC_GETFLAG.patch
Patch0024:      0024-linux-user-implement-FS_IOC_SETFLAG.patch
Patch0025:      0025-linux-user-XXX-disable-fiemap.patch.patch
Patch0026:      0026-slirp-nooutgoing.patch.patch
Patch0027:      0027-vnc-password-file-and-incoming-conn.patch
Patch0028:      0028-linux-user-add-more-blk-ioctls.patc.patch
Patch0029:      0029-linux-user-use-target_ulong.patch.patch
Patch0030:      0030-Add-support-for-DictZip-enabled-gzi.patch
Patch0031:      0031-Add-tar-container-format.patch.patch
Patch0032:      0032-Legacy-Patch-kvm-qemu-preXX-dictzip.patch
Patch0033:      0033-Legacy-Patch-kvm-qemu-preXX-report-.patch
Patch0034:      0034-console-add-question-mark-escape-op.patch
Patch0035:      0035-Make-char-muxer-more-robust-wrt-sma.patch
Patch0036:      0036-linux-user-lseek-explicitly-cast-no.patch
Patch0037:      0037-virtfs-proxy-helper-Provide-__u64-f.patch
Patch0038:      0038-gdbstub-Fix-gdb_register_coprocesso.patch
Patch0039:      0039-roms-Build-vgabios.bin.patch.patch
Patch0040:      0040-configure-Enable-PIE-for-ppc-and-pp.patch
# Please do not add patches manually here, run update_git.sh.

# roms/ipxe patches
Patch1000:      ipxe-build-Work-around-bug-in-gcc-4.8.patch
Patch1001:      ipxe-zbin-Fix-size-used-for-memset-in-al.patch
Patch1002:      ipxe-build-Avoid-strict-aliasing-warning.patch
# end roms/ipxe patches

# this is to make lint happy
Source300:      rpmlintrc
Source302:      bridge.conf
Source400:      update_git.sh
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  SDL-devel
BuildRequires:  alsa-devel
BuildRequires:  bluez-devel
%if 0%{?suse_version} >= 1130
BuildRequires:  brlapi-devel
%endif
BuildRequires:  curl-devel
BuildRequires:  cyrus-sasl-devel
%if %{build_x86_fw_from_source}
%if 0%{?suse_version} > 1110
BuildRequires:  iasl
%else
BuildRequires:  pmtools
%endif
BuildRequires:  dev86
%endif
BuildRequires:  e2fsprogs-devel
BuildRequires:  fdupes
BuildRequires:  glib2-devel
%if 0%{?suse_version} >= 1220
BuildRequires:  gtk3-devel
%else
BuildRequires:  gtk2-devel
%endif
BuildRequires:  libaio
BuildRequires:  libaio-devel
BuildRequires:  libattr-devel
BuildRequires:  libcap-devel
BuildRequires:  libcap-ng-devel
%if 0%{?suse_version} >= 1310
# 12.3 and earlier don't ship a compatible libfdt; use the bundled one there
BuildRequires:  libfdt1-devel
%endif
BuildRequires:  libgnutls-devel
BuildRequires:  libjpeg-devel
BuildRequires:  libpcap-devel
BuildRequires:  libpixman-1-0-devel
BuildRequires:  libpng-devel
BuildRequires:  libpulse-devel
BuildRequires:  libvdeplug3-devel
%if 0%{?suse_version} > 1220
BuildRequires:  makeinfo
%endif
BuildRequires:  ncurses-devel
BuildRequires:  pwdutils
BuildRequires:  python
%if 0%{?sles_version} != 11 
BuildRequires:  usbredir-devel
%endif
%if 0%{?suse_version} >= 1210
BuildRequires:  vte2-devel
%endif
%ifarch %ix86 x86_64
BuildRequires:  xen-devel
%endif
BuildRequires:  zlib-devel
%if 0%{?suse_version} >= 1140
%ifarch %ix86 x86_64
BuildRequires:  libspice-server-devel
BuildRequires:  spice-protocol-devel
%endif
%endif
Requires:       /usr/sbin/groupadd
Requires:       pwdutils
Requires:       qemu-ipxe
Requires:       qemu-seabios
Requires:       qemu-sgabios
Requires:       qemu-vgabios
Requires:       timezone
Recommends:     qemu-tools

%define firmware_files {acpi-dsdt.aml bios.bin q35-acpi-dsdt.aml sgabios.bin vgabios.bin vgabios-cirrus.bin vgabios-stdvga.bin vgabios-vmware.bin vgabios-qxl.bin optionrom/linuxboot.bin optionrom/multiboot.bin optionrom/kvmvapic.bin pxe-e1000.rom pxe-pcnet.rom pxe-ne2k_pci.rom pxe-rtl8139.rom pxe-eepro100.rom pxe-virtio.rom}

%description
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

%if 0%{?suse_version} >= 1210
%package lang
Summary:        Universal CPU emulator -- Translations
Group:          System/Emulators/PC

%description lang
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package contains translations.
%endif

%package seabios
Summary:        X86 BIOS for QEMU
Group:          System/Emulators/PC
Version:        1.7.2.2
Release:        0
BuildArch:      noarch
Conflicts:      qemu < 1.6.0

%description seabios
SeaBIOS is an open source implementation of a 16bit x86 BIOS. SeaBIOS
is the default BIOS for QEMU.

%package vgabios
Summary:        VGA BIOSes for QEMU
Group:          System/Emulators/PC
Version:        0.6c
Release:        0
BuildArch:      noarch
Conflicts:      qemu < 1.6.0

%description vgabios
VGABIOS provides the video ROM BIOSes for the following variants of VGA
emulated devices: Std VGA, QXL, Cirrus CLGD 5446 and VMware emulated
video card.

%package sgabios
Summary:        Serial Graphics Adapter BIOS for QEMU
Group:          System/Emulators/PC
Version:        8
Release:        0
BuildArch:      noarch
Conflicts:      qemu < 1.6.0

%description sgabios
The Google Serial Graphics Adapter BIOS or SGABIOS provides a means for legacy
x86 software to communicate with an attached serial console as if a video card
were attached.

%package ipxe
Summary:        PXE ROMs for QEMU NICs
Group:          System/Emulators/PC
Version:        1.0.0
Release:        0
BuildArch:      noarch
Conflicts:      qemu < 1.6.0

%description ipxe
Preboot Execution Environment (PXE) ROM support for various emulated network
adapters available with QEMU.

%package tools
Summary:        Universal CPU emulator -- Tools
Group:          System/Emulators/PC
Provides:       qemu:%_libexecdir/qemu-bridge-helper
PreReq:         permissions

%description tools
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package contains various tools, including a bridge helper.

%package guest-agent
Summary:        Universal CPU emulator -- Guest agent
Group:          System/Emulators/PC
Provides:       qemu:%_bindir/qemu-ga

%description guest-agent
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package contains the guest agent.

%prep
%setup -q #-n %name-1.6.0-rc3
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1

%patch1000 -p1
%patch1001 -p1
%patch1002 -p1

%if %{build_x86_fw_from_source}
# as a safeguard, delete the firmware files that we intend to build
for i in %firmware_files
do
  rm -f pc-bios/$i
done
%endif

%build
./configure --prefix=%_prefix --sysconfdir=%_sysconfdir \
	--libexecdir=%_libexecdir \
	--extra-cflags="%{optflags}" \
	--disable-strip \
	--enable-system --disable-linux-user \
	--enable-tools --enable-guest-agent \
        --enable-pie \ 
	--enable-docs \
	--audio-drv-list="pa alsa sdl oss" --enable-mixemu \
%if 0%{?suse_version} >= 1130
        --enable-brlapi \
%endif
	--enable-cap-ng \
	--enable-curl \
	--enable-curses \
%if 0%{?suse_version} >= 1210
	--enable-gtk \
%endif
	--enable-linux-aio \
	--enable-sdl \
%if 0%{?suse_version} >= 1140
%ifarch %ix86 x86_64
	--enable-spice \
%else
	--disable-spice \
%endif
%else
	--disable-spice \
%endif
%if 0%{?sles_version} != 11 
	--enable-usb-redir \
%endif
	--enable-vde \
	--enable-virtfs \
	--enable-vnc-jpeg \
	--enable-vnc-png \
	--enable-vnc-sasl \
	--enable-vnc-tls \
	--enable-vnc-ws \
%ifarch %ix86 x86_64
	--enable-xen \
%endif

make %{?_smp_mflags} V=1

# Firmware
%if %{build_x86_fw_from_source}
make -C roms bios
make -C roms lgplvgabios
make -C roms pxerom
make -C roms/sgabios
cp roms/sgabios/sgabios.bin pc-bios/sgabios.bin
%endif

%install
make install DESTDIR=$RPM_BUILD_ROOT
rm -fr $RPM_BUILD_ROOT/%_datadir/doc
install -D -m 644 %{SOURCE302} $RPM_BUILD_ROOT/%{_sysconfdir}/qemu/bridge.conf
%if 0%{?suse_version} >= 1210
%find_lang %name
%endif
%fdupes -s $RPM_BUILD_ROOT

%clean
rm -rf ${RPM_BUILD_ROOT}

%pre
%{_bindir}/getent group kvm >/dev/null || %{_sbindir}/groupadd -r kvm 2>/dev/null
%{_bindir}/getent group qemu >/dev/null || %{_sbindir}/groupadd -r qemu 2>/dev/null
%{_bindir}/getent passwd qemu >/dev/null || \
  %{_sbindir}/useradd -r -g qemu -G kvm -d / -s /sbin/nologin \
  -c "qemu user" qemu

%if 0%{?suse_version} >= 1130
%post tools
%set_permissions %_libexecdir/qemu-bridge-helper

%verifyscript tools
%verify_permissions %_libexecdir/qemu-bridge-helper
%endif

%files
%defattr(-, root, root)
%doc COPYING COPYING.LIB Changelog README VERSION qemu-doc.html qemu-tech.html
%_bindir/qemu-system-*
%doc %_mandir/man1/qemu.1.gz
%_datadir/%name
%exclude %_datadir/%name/bios.bin
%exclude %_datadir/%name/acpi-dsdt.aml
%exclude %_datadir/%name/q35-acpi-dsdt.aml
%exclude %_datadir/%name/vgabios.bin
%exclude %_datadir/%name/vgabios-cirrus.bin
%exclude %_datadir/%name/vgabios-qxl.bin
%exclude %_datadir/%name/vgabios-stdvga.bin
%exclude %_datadir/%name/vgabios-vmware.bin
%exclude %_datadir/%name/sgabios.bin
%exclude %_datadir/%name/pxe-e1000.rom
%exclude %_datadir/%name/pxe-eepro100.rom
%exclude %_datadir/%name/pxe-pcnet.rom
%exclude %_datadir/%name/pxe-ne2k_pci.rom
%exclude %_datadir/%name/pxe-rtl8139.rom
%exclude %_datadir/%name/pxe-virtio.rom
%dir %_sysconfdir/%name
%config %_sysconfdir/%name/target-x86_64.conf

%if 0%{?suse_version} >= 1210
%files lang -f %name.lang
%defattr(-, root, root)
%endif

%files seabios
%defattr(-, root, root)
%_datadir/%name/bios.bin
%_datadir/%name/acpi-dsdt.aml
%_datadir/%name/q35-acpi-dsdt.aml

%files vgabios
%defattr(-, root, root)
%_datadir/%name/vgabios.bin
%_datadir/%name/vgabios-cirrus.bin
%_datadir/%name/vgabios-qxl.bin
%_datadir/%name/vgabios-stdvga.bin
%_datadir/%name/vgabios-vmware.bin

%files sgabios
%defattr(-, root, root)
%_datadir/%name/sgabios.bin

%files ipxe
%defattr(-, root, root)
%_datadir/%name/pxe-e1000.rom
%_datadir/%name/pxe-eepro100.rom
%_datadir/%name/pxe-pcnet.rom
%_datadir/%name/pxe-ne2k_pci.rom
%_datadir/%name/pxe-rtl8139.rom
%_datadir/%name/pxe-virtio.rom

%files tools
%defattr(-, root, root)
%doc %_mandir/man1/qemu-img.1.gz
%doc %_mandir/man1/virtfs-proxy-helper.1.gz
%doc %_mandir/man8/qemu-nbd.8.gz
%_bindir/qemu-io
%_bindir/qemu-img
%_bindir/qemu-nbd
%_bindir/virtfs-proxy-helper
%verify(not mode) %_libexecdir/qemu-bridge-helper
%dir %_sysconfdir/%name
%config %_sysconfdir/%name/bridge.conf

%files guest-agent
%defattr(-, root, root)
%attr(755,root,kvm) %_bindir/qemu-ga

%changelog
